Overview | Package | Class | Tree | Deprecated | Index | Help
| Bouncy Castle Cryptography 1.21
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.bouncycastle.jce.provider
Class WrapCipherSpi

    java.lang.Object
      |
      +--javax.crypto.CipherSpi
            |
            +--org.bouncycastle.jce.provider.WrapCipherSpi

All Implemented Interfaces:
  PBE

Direct Known Subclasses:
  JCEBlockCipher, JCEElGamalCipher, JCEIESCipher, JCERSACipher, JCEStreamCipher, WrapCipherSpi.AESWrap, WrapCipherSpi.DESEDEWrap, WrapCipherSpi.RC2Wrap

public abstract class WrapCipherSpi
extends CipherSpi
implements PBE

Nested Class Summary
`static class` | `WrapCipherSpi.AESWrap`
`static class` | `WrapCipherSpi.DESEDEWrap`
`static class` | `WrapCipherSpi.RC2Wrap`

Nested classes inherited from class org.bouncycastle.jce.provider.PBE
`PBE.Util`

Field Summary
`protected java.security.AlgorithmParameters` | `engineParams`
`protected int` | `pbeHash`
`protected int` | `pbeIvSize`
`protected int` | `pbeKeySize`
`protected int` | `pbeType`
`protected Wrapper` | `wrapEngine`

Fields inherited from interface org.bouncycastle.jce.provider.PBE
`MD5, PKCS12, PKCS5S1, PKCS5S2, RIPEMD160, SHA1, TIGER`

Constructor Summary
`protected` | `WrapCipherSpi()`
`protected` | `WrapCipherSpi(Wrapper wrapEngine)`

Method Summary
`protected byte[]` | `engineDoFinal(byte[] input, int inputOffset, int inputLen)` Encrypts or decrypts data in a single-part operation, or finishes a multiple-part operation.
`protected int` | `engineDoFinal(byte[] input, int inputOffset, int inputLen, byte[] output, int outputOffset)` Encrypts or decrypts data in a single-part operation, or finishes a multiple-part operation.
`protected int` | `engineGetBlockSize()` Returns the block size (in bytes).
`protected byte[]` | `engineGetIV()` Returns the initialization vector (IV) in a new buffer.
`protected int` | `engineGetKeySize(java.security.Key key)` Returns the key size of the given key object.
`protected int` | `engineGetOutputSize(int inputLen)` Returns the length in bytes that an output buffer would need to be in order to hold the result of the next `update` or `doFinal` operation, given the input length `inputLen` (in bytes).
`protected java.security.AlgorithmParameters` | `engineGetParameters()` Returns the parameters used with this cipher.
`protected void` | `engineInit(int opmode, java.security.Key key, java.security.spec.AlgorithmParameterSpec params, java.security.SecureRandom random)` Initializes this cipher with a key, a set of algorithm parameters, and a source of randomness.
`protected void` | `engineInit(int opmode, java.security.Key key, java.security.AlgorithmParameters params, java.security.SecureRandom random)` Initializes this cipher with a key, a set of algorithm parameters, and a source of randomness.
`protected void` | `engineInit(int opmode, java.security.Key key, java.security.SecureRandom random)` Initializes this cipher with a key and a source of randomness.
`protected void` | `engineSetMode(java.lang.String mode)` Sets the mode of this cipher.
`protected void` | `engineSetPadding(java.lang.String padding)` Sets the padding mechanism of this cipher.
`protected java.security.Key` | `engineUnwrap(byte[] wrappedKey, java.lang.String wrappedKeyAlgorithm, int wrappedKeyType)` Unwrap a previously wrapped key.
`protected byte[]` | `engineUpdate(byte[] input, int inputOffset, int inputLen)` Continues a multiple-part encryption or decryption operation (depending on how this cipher was initialized), processing another data part.
`protected int` | `engineUpdate(byte[] input, int inputOffset, int inputLen, byte[] output, int outputOffset)` Continues a multiple-part encryption or decryption operation (depending on how this cipher was initialized), processing another data part.
`protected byte[]` | `engineWrap(java.security.Key key)` Wrap a key.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### pbeType

    protected int pbeType

### pbeHash

    protected int pbeHash

### pbeKeySize

    protected int pbeKeySize

### pbeIvSize

    protected int pbeIvSize

### engineParams

    protected java.security.AlgorithmParameters engineParams

### wrapEngine

    protected Wrapper wrapEngine

Constructor Detail

### WrapCipherSpi

    protected WrapCipherSpi()

### WrapCipherSpi

    protected WrapCipherSpi(Wrapper wrapEngine)

Method Detail

### engineGetBlockSize

    protected int engineGetBlockSize()

  Description copied from class: `CipherSpi`
  Returns the block size (in bytes).

  Specified by:
    `engineGetBlockSize` in class `CipherSpi`
  Returns:
    the block size (in bytes), or 0 if the underlying algorithm is not a block cipher

### engineGetIV

    protected byte[] engineGetIV()

  Description copied from class: `CipherSpi`
  Returns the initialization vector (IV) in a new buffer.

  This is useful in the context of password-based encryption or decryption, where the IV is derived from a user-provided passphrase.

  Specified by:
    `engineGetIV` in class `CipherSpi`
  Returns:
    the initialization vector in a new buffer, or null if the underlying algorithm does not use an IV, or if the IV has not yet been set.

### engineGetKeySize

    protected int engineGetKeySize(java.security.Key key)

  Description copied from class: `CipherSpi`
  Returns the key size of the given key object.

  This concrete method has been added to this previously-defined abstract class. It throws an `UnsupportedOperationException` if it is not overridden by the provider.

  Overrides:
    `engineGetKeySize` in class `CipherSpi`
  Parameters:
    `key` - the key object.
  Returns:
    the key size of the given key object.

### engineGetOutputSize

    protected int engineGetOutputSize(int inputLen)

  Description copied from class: `CipherSpi`
  Returns the length in bytes that an output buffer would need to be in order to hold the result of the next `update` or `doFinal` operation, given the input length `inputLen` (in bytes).

  This call takes into account any unprocessed (buffered) data from a previous `update` call, and padding.

  The actual output length of the next `update` or `doFinal` call may be smaller than the length returned by this method.

  Specified by:
    `engineGetOutputSize` in class `CipherSpi`
  Parameters:
    `inputLen` - the input length (in bytes)
  Returns:
    the required output buffer size (in bytes)

### engineGetParameters

    protected java.security.AlgorithmParameters engineGetParameters()

  Description copied from class: `CipherSpi`
  Returns the parameters used with this cipher.

  The returned parameters may be the same that were used to initialize this cipher, or may contain a combination of default and random parameter values used by the underlying cipher implementation if this cipher requires algorithm parameters but was not initialized with any.

  Specified by:
    `engineGetParameters` in class `CipherSpi`
  Returns:
    the parameters used with this cipher, or null if this cipher does not use any parameters.

### engineSetMode

    protected void engineSetMode(java.lang.String mode)

  Description copied from class: `CipherSpi`
  Sets the mode of this cipher.

  Specified by:
    `engineSetMode` in class `CipherSpi`
  Parameters:
    `mode` - the cipher mode

### engineSetPadding

    protected void engineSetPadding(java.lang.String padding)
                             throws NoSuchPaddingException

  Description copied from class: `CipherSpi`
  Sets the padding mechanism of this cipher.

  Specified by:
    `engineSetPadding` in class `CipherSpi`
  Parameters:
    `padding` - the padding mechanism
  Throws:
    `NoSuchPaddingException` - if the requested padding mechanism does not exist

### engineInit

    protected void engineInit(int opmode,
                              java.security.Key key,
                              java.security.spec.AlgorithmParameterSpec params,
                              java.security.SecureRandom random)
                       throws java.security.InvalidKeyException,
                              java.security.InvalidAlgorithmParameterException

  Description copied from class: `CipherSpi`
  Initializes this cipher with a key, a set of algorithm parameters, and a source of randomness.

  The cipher is initialized for one of the following four operations: encryption, decryption, key wrapping or key unwrapping, depending on the value of `opmode`.

  If this cipher requires any algorithm parameters and `params` is null, the underlying cipher implementation is supposed to generate the required parameters itself (using provider-specific default or random values) if it is being initialized for encryption or key wrapping, and raise an `InvalidAlgorithmParameterException` if it is being initialized for decryption or key unwrapping. The generated parameters can be retrieved using engineGetParameters or engineGetIV (if the parameter is an IV).

  If this cipher (including its underlying feedback or padding scheme) requires any random bytes (e.g., for parameter generation), it will get them from `random`.

  Note that when a Cipher object is initialized, it loses all previously-acquired state. In other words, initializing a Cipher is equivalent to creating a new instance of that Cipher and initializing it.

  Specified by:
    `engineInit` in class `CipherSpi`
  Parameters:
    `opmode` - the operation mode of this cipher (this is one of the following: `ENCRYPT_MODE`, `DECRYPT_MODE`, `WRAP_MODE` or `UNWRAP_MODE`)
    `key` - the encryption key
    `params` - the algorithm parameters
    `random` - the source of randomness
  Throws:
    `java.security.InvalidAlgorithmParameterException` - if the given algorithm parameters are inappropriate for this cipher, or if this cipher is being initialized for decryption and requires algorithm parameters and `params` is null.
    `java.security.InvalidKeyException` - if the given key is inappropriate for initializing this cipher

### engineInit

    protected void engineInit(int opmode,
                              java.security.Key key,
                              java.security.AlgorithmParameters params,
                              java.security.SecureRandom random)
                       throws java.security.InvalidKeyException,
                              java.security.InvalidAlgorithmParameterException

  Description copied from class: `CipherSpi`
  Initializes this cipher with a key, a set of algorithm parameters, and a source of randomness.

  The cipher is initialized for one of the following four operations: encryption, decryption, key wrapping or key unwrapping, depending on the value of `opmode`.

  If this cipher requires any algorithm parameters and `params` is null, the underlying cipher implementation is supposed to generate the required parameters itself (using provider-specific default or random values) if it is being initialized for encryption or key wrapping, and raise an `InvalidAlgorithmParameterException` if it is being initialized for decryption or key unwrapping. The generated parameters can be retrieved using engineGetParameters or engineGetIV (if the parameter is an IV).

  If this cipher (including its underlying feedback or padding scheme) requires any random bytes (e.g., for parameter generation), it will get them from `random`.

  Note that when a Cipher object is initialized, it loses all previously-acquired state. In other words, initializing a Cipher is equivalent to creating a new instance of that Cipher and initializing it.

  Specified by:
    `engineInit` in class `CipherSpi`
  Parameters:
    `opmode` - the operation mode of this cipher (this is one of the following: `ENCRYPT_MODE`, `DECRYPT_MODE`, `WRAP_MODE` or `UNWRAP_MODE`)
    `key` - the encryption key
    `params` - the algorithm parameters
    `random` - the source of randomness
  Throws:
    `java.security.InvalidAlgorithmParameterException` - if the given algorithm parameters are inappropriate for this cipher, or if this cipher is being initialized for decryption and requires algorithm parameters and `params` is null.
    `java.security.InvalidKeyException` - if the given key is inappropriate for initializing this cipher

### engineInit

    protected void engineInit(int opmode,
                              java.security.Key key,
                              java.security.SecureRandom random)
                       throws java.security.InvalidKeyException

  Description copied from class: `CipherSpi`
  Initializes this cipher with a key and a source of randomness.

  The cipher is initialized for one of the following four operations: encryption, decryption, key wrapping or key unwrapping, depending on the value of `opmode`.

  If this cipher requires any algorithm parameters that cannot be derived from the given `key`, the underlying cipher implementation is supposed to generate the required parameters itself (using provider-specific default or random values) if it is being initialized for encryption or key wrapping, and raise an `InvalidKeyException` if it is being initialized for decryption or key unwrapping. The generated parameters can be retrieved using engineGetParameters or engineGetIV (if the parameter is an IV).

  If this cipher (including its underlying feedback or padding scheme) requires any random bytes (e.g., for parameter generation), it will get them from `random`.

  Note that when a Cipher object is initialized, it loses all previously-acquired state. In other words, initializing a Cipher is equivalent to creating a new instance of that Cipher and initializing it.

  Specified by:
    `engineInit` in class `CipherSpi`
  Parameters:
    `opmode` - the operation mode of this cipher (this is one of the following: `ENCRYPT_MODE`, `DECRYPT_MODE`, `WRAP_MODE` or `UNWRAP_MODE`)
    `key` - the encryption key
    `random` - the source of randomness
  Throws:
    `java.security.InvalidKeyException` - if the given key is inappropriate for initializing this cipher, or if this cipher is being initialized for decryption and requires algorithm parameters that cannot be determined from the given key.

### engineUpdate

    protected byte[] engineUpdate(byte[] input,
                                  int inputOffset,
                                  int inputLen)

  Description copied from class: `CipherSpi`
  Continues a multiple-part encryption or decryption operation (depending on how this cipher was initialized), processing another data part.

  The first `inputLen` bytes in the `input` buffer, starting at `inputOffset` inclusive, are processed, and the result is stored in a new buffer.

  Specified by:
    `engineUpdate` in class `CipherSpi`
  Parameters:
    `input` - the input buffer
    `inputOffset` - the offset in `input` where the input starts
    `inputLen` - the input length
  Returns:
    the new buffer with the result, or null if the underlying cipher is a block cipher and the input data is too short to result in a new block.

### engineUpdate

    protected int engineUpdate(byte[] input,
                               int inputOffset,
                               int inputLen,
                               byte[] output,
                               int outputOffset)

  Description copied from class: `CipherSpi`
  Continues a multiple-part encryption or decryption operation (depending on how this cipher was initialized), processing another data part.

  The first `inputLen` bytes in the `input` buffer, starting at `inputOffset` inclusive, are processed, and the result is stored in the `output` buffer, starting at `outputOffset` inclusive.

  If the `output` buffer is too small to hold the result, a `ShortBufferException` is thrown.

  Specified by:
    `engineUpdate` in class `CipherSpi`
  Parameters:
    `input` - the input buffer
    `inputOffset` - the offset in `input` where the input starts
    `inputLen` - the input length
    `output` - the buffer for the result
    `outputOffset` - the offset in `output` where the result is stored
  Returns:
    the number of bytes stored in `output`

### engineDoFinal

    protected byte[] engineDoFinal(byte[] input,
                                   int inputOffset,
                                   int inputLen)
                            throws IllegalBlockSizeException,
                                   BadPaddingException

  Description copied from class: `CipherSpi`
  Encrypts or decrypts data in a single-part operation, or finishes a multiple-part operation. The data is encrypted or decrypted, depending on how this cipher was initialized.

  The first `inputLen` bytes in the `input` buffer, starting at `inputOffset` inclusive, and any input bytes that may have been buffered during a previous `update` operation, are processed, with padding (if requested) being applied. The result is stored in a new buffer.

  A call to this method resets this cipher object to the state it was in when previously initialized via a call to `engineInit`. That is, the object is reset and available to encrypt or decrypt (depending on the operation mode that was specified in the call to `engineInit`) more data.

  Specified by:
    `engineDoFinal` in class `CipherSpi`
  Parameters:
    `input` - the input buffer
    `inputOffset` - the offset in `input` where the input starts
    `inputLen` - the input length
  Returns:
    the new buffer with the result
  Throws:
    `BadPaddingException` - if this cipher is in decryption mode, and (un)padding has been requested, but the decrypted data is not bounded by the appropriate padding bytes
    `IllegalBlockSizeException` - if this cipher is a block cipher, no padding has been requested (only in encryption mode), and the total input length of the data processed by this cipher is not a multiple of block size

### engineDoFinal

    protected int engineDoFinal(byte[] input,
                                int inputOffset,
                                int inputLen,
                                byte[] output,
                                int outputOffset)
                         throws IllegalBlockSizeException,
                                BadPaddingException

  Description copied from class: `CipherSpi`
  Encrypts or decrypts data in a single-part operation, or finishes a multiple-part operation. The data is encrypted or decrypted, depending on how this cipher was initialized.

  The first `inputLen` bytes in the `input` buffer, starting at `inputOffset` inclusive, and any input bytes that may have been buffered during a previous `update` operation, are processed, with padding (if requested) being applied. The result is stored in the `output` buffer, starting at `outputOffset` inclusive.

  If the `output` buffer is too small to hold the result, a `ShortBufferException` is thrown.

  A call to this method resets this cipher object to the state it was in when previously initialized via a call to `engineInit`. That is, the object is reset and available to encrypt or decrypt (depending on the operation mode that was specified in the call to `engineInit`) more data.

  Specified by:
    `engineDoFinal` in class `CipherSpi`
  Parameters:
    `input` - the input buffer
    `inputOffset` - the offset in `input` where the input starts
    `inputLen` - the input length
    `output` - the buffer for the result
    `outputOffset` - the offset in `output` where the result is stored
  Returns:
    the number of bytes stored in `output`
  Throws:
    `IllegalBlockSizeException` - if this cipher is a block cipher, no padding has been requested (only in encryption mode), and the total input length of the data processed by this cipher is not a multiple of block size
    `BadPaddingException` - if this cipher is in decryption mode, and (un)padding has been requested, but the decrypted data is not bounded by the appropriate padding bytes

### engineWrap

    protected byte[] engineWrap(java.security.Key key)
                         throws IllegalBlockSizeException,
                                java.security.InvalidKeyException

  Description copied from class: `CipherSpi`
  Wrap a key.

  This concrete method has been added to this previously-defined abstract class. (For backwards compatibility, it cannot be abstract.) It may be overridden by a provider to wrap a key. Such an override is expected to throw an IllegalBlockSizeException or InvalidKeyException (under the specified circumstances), if the given key cannot be wrapped. If this method is not overridden, it always throws an UnsupportedOperationException.

  Overrides:
    `engineWrap` in class `CipherSpi`
  Parameters:
    `key` - the key to be wrapped.
  Returns:
    the wrapped key.
  Throws:
    `IllegalBlockSizeException` - if this cipher is a block cipher, no padding has been requested, and the length of the encoding of the key to be wrapped is not a multiple of the block size.
    `java.security.InvalidKeyException` - if it is impossible or unsafe to wrap the key with this cipher (e.g., a hardware protected key is being passed to a software-only cipher).

### engineUnwrap

    protected java.security.Key engineUnwrap(byte[] wrappedKey,
                                             java.lang.String wrappedKeyAlgorithm,
                                             int wrappedKeyType)
                                      throws java.security.InvalidKeyException

  Description copied from class: `CipherSpi`
  Unwrap a previously wrapped key.

  This concrete method has been added to this previously-defined abstract class. (For backwards compatibility, it cannot be abstract.) It may be overridden by a provider to unwrap a previously wrapped key. Such an override is expected to throw an InvalidKeyException if the given wrapped key cannot be unwrapped. If this method is not overridden, it always throws an UnsupportedOperationException.

  Overrides:
    `engineUnwrap` in class `CipherSpi`
  Parameters:
    `wrappedKey` - the key to be unwrapped.
    `wrappedKeyAlgorithm` - the algorithm associated with the wrapped key.
    `wrappedKeyType` - the type of the wrapped key. This is one of `SECRET_KEY`, `PRIVATE_KEY`, or `PUBLIC_KEY`.
  Returns:
    the unwrapped key.
  Throws:
    `java.security.InvalidKeyException` - if `wrappedKey` does not represent a wrapped key, or if the algorithm associated with the wrapped key is different from `wrappedKeyAlgorithm` and/or its key type is different from `wrappedKeyType`.

Overview | Package | Class | Tree | Deprecated | Index | Help
| Bouncy Castle Cryptography 1.21
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD